
#INCLUDE "dcdialog.CH"
#INCLUDE "dmlb.CH"
#INCLUDE "dcbitmap.CH"

#DEFINE ODBCDBE_NOUTIL
#INCLUDE "odbcdbe.CH"

#pragma Library("ADAC20B.LIB")

// EXTERNAL OdbcListSqlKeywords

FUNCTION Main()

LOCAL cConnect, oSession, oMenuBar, oTableMenu, oWindowMenu, GetList[0], ;
      GetOptions, aDataSources, oViewMenu

PUBLIC oMainWindow

IF ! DbeLoad( "ODBCDBE" )
    DC_WinAlert( "Unable to load ODBCDBE", "ODBC Driver",, ;
                  XBPMB_WARNING + XBPMB_APPMODAL )

  QUIT
ENDIF

dbeSetDefault('ODBCDBE')

// oSession := SQLConnect('Northwind','(Local)')
oSession := SQLConnect('GDLONG','crm2011')

IF Valtype(oSession) # 'O' .OR. !oSession:isConnected()
  RETURN .f.
ENDIF

/*
aDataSources := DbeInfo(COMPONENT_DATA,ODBCDBE_DATASOURCES)
DC_ArrayView(aDataSources)
*/

DC_ClearEvents()

DCMENUBAR oMenuBar

  USE @GDLONG.TABLES

  DCSUBMENU oTableMenu PROMPT 'Browse' PARENT oMenuBar

  DO WHILE !Eof()
    DCMENUITEM PROMPT FIELD->Table_Name ;
      PARENT oTableMenu ;
      ACTION &('{||SQLBrowseCall("' + FIELD->Table_name + '")}')
    DC_DbSkip()
  ENDDO

  DCSUBMENU oTableMenu PROMPT 'Update' PARENT oMenuBar

  DbGoTop()
  DO WHILE !Eof()
    DCMENUITEM PROMPT FIELD->Table_Name ;
      PARENT oTableMenu ;
      ACTION &('{||SQL_UpdateCall("' + FIELD->Table_name + '")}')
    DC_DbSkip()
  ENDDO

  CLOSE ALL

  DCSUBMENU oWindowMenu PROMPT 'Window' PARENT oMenuBar
    DCMENUITEM 'SQL Statement' ;
      PARENT oWindowMenu ;
      ACTION {|o|o:=Thread():new(), ;
                 o:start({||SQLStatement()}) }
DCGETOPTIONS ;
   WINDOWHEIGHT 600 ;
   WINDOWWIDTH 800 ;
   BITMAP BITMAP_EXPRESS_BACKGROUND1

CLOSE ALL

oSession:disConnect()

DCREAD GUI ;
   OPTIONS GetOptions ;
   TITLE 'Golden Long ...' ;
   EVAL {|o|M->oMainWindow := o}

RETURN nil

* --------------

FUNCTION SQLStatement()

LOCAL GetList[0], cSQLStatement := 'SELECT * FROM [database] ;', ;
      GetOptions

@ 0,0 DCPUSHBUTTON CAPTION 'Run' ;
      SIZE 5,1 ;
      ACTION {||SQLBrowseCall(cSQLStatement)}

@ 0,7 DCSAY 'SQL Statement:' ;
      SAYSIZE 0 ;
      SAYBOTTOM

@ 1,0 DCMULTILINE cSQLStatement ;
      SIZE 50,5 ;
      FONT '10.Alaska Crt' ;
      NOHSCROLL

DCGETOPTIONS ;
   NOMAXBUTTON ;
   AUTORESIZE

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   ADDBUTTONS ;
   APPWINDOW M->oMainWindow:drawingArea ;
   TITLE 'Enter SQL Statement'

RETURN nil

* --------------

FUNCTION SQLBrowseCall( cSQLStatement )

LOCAL oThread := Thread():new()
oThread:start({||SQLBrowse(cSQLStatement)})

RETURN nil

* --------------

FUNCTION SQLBrowse( cSQLStatement )

LOCAL GetList[0], i, oBrowse, aFields, nWidth, cAlias, bErrorBlock, ;
      oSession, lError, GetOptions

oSession := SQLConnect()
IF !oSession:isConnected()
  RETURN .f.
ENDIF

bErrorBlock := ErrorBlock({|e|SQLError(e,cSQLStatement)})

lError := .t.
BEGIN SEQUENCE

dc_debugqout('SQLBrose will use: ' + dc_xtoc(cSQLStatement))

USE (cSQLStatement)
lError := .f.
END SEQUENCE
ErrorBlock(bErrorBlock)

IF lError
  RETURN .f.
ENDIF

cAlias := Alias()

aFields := dbStruct()

nWidth := 0

*
* Note: Memo fields show proper values here, but not shown in following browse
*
FOR i := 1 TO Len(aFields)

  if aFields[i,2] $ 'MQ'
     dc_debugqout('Field:' + dc_xtoc(i) + ' Field type:' + dc_xtoc(aFields[i,1]) + ' ' + dc_xtoc(aFields[i,2]))
     dc_debugqout('     >valtype():' + dc_xtoc(valtype(&(aFields[i,1]))) + '  Field value:' + dc_xtoc((&(aFields[i,1]))))
  endif

  nWidth += aFields[i,3]
NEXT

@ 0,0 DCBROWSE ;
   OBJECT oBrowse ;
   ALIAS cAlias ;
   SIZE 80,15 ;
   _FIT nWidth < 60 ;
   _NOHSCROLL nWidth < 60 ;
   PRESENTATION DC_BrowPres()

FOR i := 1 TO Len(aFields)
  DCBROWSECOL DATA DC_FieldWBlock(aFields[i,1],Alias()) ;
    PARENT oBrowse HEADER aFields[i,1] WIDTH Min(20,aFields[i,3])
NEXT

DCGETOPTIONS ;
   AUTORESIZE

DCREAD GUI FIT ADDBUTTONS ;
   TITLE cSQLStatement ;
   OPTIONS GetOptions ;
   APPWINDOW M->oMainWindow:drawingArea

CLOSE ALL
oSession:disconnect()

RETURN .t.

* --------------

FUNCTION SQL_UpdateCall( cSQLStatement )

LOCAL oThread := Thread():new()
oThread:start({||SQL_Update(cSQLStatement)})

RETURN nil

* --------------

FUNCTION SQL_Update( cSQLStatement )

LOCAL GetList[0], i, oBrowse, aFields, nWidth, cAlias, bErrorBlock, ;
      oSession, lError, GetOptions

LOCAL xValue
LOCAL nMemoFldCount := 0

oSession := SQLConnect()
IF !oSession:isConnected()
  RETURN .f.
ENDIF

bErrorBlock := ErrorBlock({|e|SQLError(e,cSQLStatement)})

lError := .t.
BEGIN SEQUENCE

dc_debugqout('SQL_Update will use: ' + dc_xtoc(cSQLStatement))

USE (cSQLStatement) shared // exclusive // shared //
lError := .f.
END SEQUENCE
ErrorBlock(bErrorBlock)

IF lError
  RETURN .f.
ENDIF

cAlias := Alias()

aFields := dbStruct()

DC_WinAlert('will update all memo fields in ' + alias() ;
              + ' appending a char to each field')

if ! eof()

   dc_debugqout('Update all memo fields in current record ...')
   if DbRLock()  // seems not necessary
                 // but same result even if not included
                 // also same result if using DbLock

      FOR i := 1 to Len(aFields)

        if aFields[i,2] $ 'CM'
           xValue := fieldget(i)

           dc_debugqout('Field:' + dc_xtoc(i) + ' Field type:' + dc_xtoc(aFields[i,1]) + ' ' + dc_xtoc(aFields[i,2]))
           dc_debugqout('     >valtype():' + dc_xtoc(valtype(xValue)) + '  Field value:' + dc_xtoc(xValue))

           xValue := trim(xValue) + 'x'
           fieldput(i, xValue)
           dc_debugqout("  appending 'x' to field, new value:" + dc_xtoc((&(aFields[i,1]))))

           // count no. of memo fields changed
           if aFields[i,2] $ 'M'
              nMemoFldCount ++
           endif

        endif

      NEXT

      dc_debugqout('Found no. of memo fields: ' + dc_xtoc(nMemoFldCount))

      // - the following will fail if any memo field has been updated
      DBRUnlock()  // fails here if this is added - function sequence error
      dbCommit()   // otherwise failed here
                   // if both above removed, will fail at CLOSE ALL later

      dc_debugqout('Done dbCommit')
   else
      dc_debugqout('DbRLock fails')
   endif
endif

CLOSE ALL
oSession:disconnect()

RETURN .t.

* --------------

FUNCTION SQLConnect(cDatabase,cServer,cUserID,cPassword)

STATIC saConnect := {}

LOCAL cConnect, oSession, GetList[0], nFound

cServer := 'crm2011'  // '(Local)'
cConnect := "DBE=ODBCDBE"
cConnect += ";DRIVER=SQL Server"

IF Empty(cDatabase)
  cDatabase := Atail(saConnect)[1]
ENDIF

DCQDEBUG saConnect, cDatabase

/*
IF Empty(cUserID)
  nFound := AScan(saConnect,{|a|a[1]==Upper(cDatabase)})
  IF nFound > 0
    cServer := saConnect[nFound,2]
    cUserID := saConnect[nFound,3]
    cPassword := saConnect[nFound,4]
  ELSE
    cUserID := Space(30)
    cPassword := Space(30)
    @ 0,0 DCSAY ' User ID' GET cUserID SAYRIGHT
    @ 1,0 DCSAY 'Password' GET cPassword SAYRIGHT PASSWORD
    DCREAD GUI FIT ADDBUTTONS ;
      ENTEREXIT ;
      TITLE 'Login Information for ' + cDataBase
    IF Empty(cUserID)
      RETURN .f.
    ENDIF
  ENDIF
ENDIF
*/

cConnect += ";SERVER=" + 'crm2011'  // '(Local)' // '10.0.0.60'  //

 /*
cConnect += ";UID=" + 'JL'  // Alltrim(cUserID)

cConnect += ";PWD=" + 'JL168'  //  Alltrim(cPassword)
 */

cConnect += ";DATABASE=" + cDatabase

// cConnect += ";WSID=WorkStationID"

cConnect += ";Trusted_Connection=Yes"

oSession := DacSession():new( cConnect )

nFound := 0
cUserId := ''
cPassword := ''

IF !oSession:isConnected()
  DC_WinAlert( "Unable to establish connection to ODBC Server" + Chr(13) + ;
               "Error Code: " + Alltrim(Str(oSession:getLastError())) + Chr(13) + ;
               oSession:getLastMessage() + ';' + cConnect )
ELSEIF nFound = 0
  AADD( saConnect, { Upper(cDatabase), Alltrim(cServer), ;
                     Alltrim(cUserId), Alltrim(cPassword) })
ELSE
  saConnect[nFound,1] := cDatabase
  saConnect[nFound,2] := cServer
  saConnect[nFound,3] := cUserID
  saConnect[nFound,4] := cPassword
ENDIF

RETURN oSession

* ----------------

STATIC FUNCTION SQLError( oError, cSQLStatement )

LOCAL cMessage := ''

cSQLStatement += Chr(13)+Chr(13) + ;
  'Make sure that the statement ends with a semi-colon (;)'

DC_WinAlert(cSQLStatement, 'SQL Statement Error')

BREAK

RETURN nil
